cat('choose demo box with name > R_DemoBox_2 < !\n')
DemoBoxPlayer <-
function (DemoBoxName, DemoBoxPath = ".", main, SlideWidthFactor, 
    SlideHeightFactor = 1, CodeHeightFactor = 1, start = TRUE, 
    debug = !TRUE) 
{
    require("tcltk")
    where <- environment()
    if (missing(DemoBoxName)) 
        DemoBoxName <- tkchooseDirectory(title = "Select directory with DemoBox", 
            initialdir = getwd())
    else {
        if (0 == length(grep("^R_DemoBox_", DemoBoxName))) 
            DemoBoxName <- paste("R_DemoBox_", DemoBoxName, sep = "")
        DemoBoxName <- file.path(DemoBoxPath, DemoBoxName)
    }
    DemoBoxName <- as.character(DemoBoxName)
    if (debug) 
        cat("path:", DemoBoxPath, "-- name:", DemoBoxName, "\n")
    if (0 == length(DemoBoxName)) 
        return("Warning: no demo box file choosen")
    if (!file.exists(DemoBoxName)) 
        return(paste("Warning: sorry,", DemoBoxName, "not found"))
    DemoBoxPath <- DemoBoxName
    DemoBoxName <- sub(paste(".*", .Platform$file.sep, sep = ""), 
        "", DemoBoxName)
    if (debug) 
        cat("path:", DemoBoxPath, "-- name:", DemoBoxName, "\n")
    print(paste("DemoBox '", DemoBoxName, "' will be opened", 
        sep = ""))
    cfg <- readLines(file.path(DemoBoxPath, paste(DemoBoxName, 
        ".config", sep = "")))
    if (missing(SlideWidthFactor)) 
        SlideWidthFactor <- as.numeric(sub(".*[-] ", "", grep("SlideWidth", 
            cfg, value = TRUE)))
    if (missing(SlideHeightFactor)) 
        SlideHeightFactor <- as.numeric(sub(".*[-] ", "", grep("SlideHeight", 
            cfg, value = TRUE)))
    if (missing(CodeHeightFactor)) 
        CodeHeightFactor <- as.numeric(sub(".*[-] ", "", grep("CodeHeight", 
            cfg, value = TRUE)))
    if (debug) 
        cat("factors:", SlideWidthFactor, SlideHeightFactor, 
            CodeHeightFactor)
    chunks <- scan(file.path(DemoBoxPath, paste(DemoBoxName, 
        ".R", sep = "")), "", sep = "\n")
    if (debug) 
        print(chunks[outer(0:2, grep("^[#][0-9]+[:]", chunks), 
            FUN = "+")])
    tw.height <- 17 * SlideHeightFactor
    cw.height <- 17 * CodeHeightFactor
    geo.height <- round(15 * (tw.height + cw.height) + 33)
    tw.height <- as.character(tw.height, 1)
    cw.height <- as.character(round(cw.height))
    w.width <- 52 * SlideWidthFactor
    geo.width <- round(w.width * 5)
    w.width <- as.character(round(w.width))
    if (debug) 
        cat("tw.height, geo.height, cw.height, w.width, geo.width:", 
            tw.height, geo.height, cw.height, w.width, geo.width, 
            "\n")
    allcodechunks <- paste("@\nReport of activated chunks from: ", 
        date(), "\n  ", sep = "")
    if (debug) 
        cat("initialize history: done")
    if (start == TRUE) {
        no <- 0
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunks)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunks)
        if (length(no.end) == 0 || is.na(no.end) || length(no.start) == 
            0 || is.na(no.start) || is.nan(no.end) || is.nan(no.start)) {
            if (debug) 
                cat("# no start chunk to evaluate\n")
        }
        else {
            code <- chunks[no.start:no.end]
            eval(parse(text = code), envir = where)
            if (debug) 
                cat("start chunk evaluated")
            code <- paste(code, collapse = "\n")
            h <- paste(rep("#", 60), collapse = "")
            code <- sub("#0:", h, code)
            code <- sub("#:0", h, code)
            allcodechunks <- c(allcodechunks, paste("\n@\n@<", 
                "<start@>", ">=", sep = ""), code, "\n@")
            assign("allcodechunks", allcodechunks, envir = where)
        }
    }
    if (debug) 
        cat("start chunk: done")
    secno <- tclVar("1")
    show.next.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secno)) + 1)
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunks)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunks)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        if (debug) 
            cat("put code", no)
        code <- paste(chunks[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttext, "0.0", "end")
            tkinsert(ttext, "0.0", code)
            tclvalue(secno) <- as.character(no)
        }
        if (debug) 
            cat("put text", no)
        tkdelete(tw, "0.0", "end")
        text.pic <- file.path(DemoBoxPath, paste(DemoBoxName, 
            "-", no, ".gif", sep = ""))
        if (0 < no) {
            print(text.pic)
            text.ok <- TRUE
            if (file.exists(text.pic)) 
                tcl("createandshowimagegif", tw, text.pic, "0.0")
            else {
                text.pic <- sub(".gif", ".ppm", text.pic)
                if (file.exists(text.pic)) 
                  tcl("createandshowimageppm", tw, text.pic, 
                    "0.0")
                else {
                }
            }
        }
        if (debug) 
            cat("get chunk and pic: done")
    }
    show.back.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secno)) - 1)
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunks)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunks)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        if (debug) 
            cat("put code", no)
        code <- paste(chunks[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttext, "0.0", "end")
            tkinsert(ttext, "0.0", code)
            tclvalue(secno) <- as.character(no)
        }
        if (debug) 
            cat("put text", no)
        tkdelete(tw, "0.0", "end")
        text.pic <- file.path(DemoBoxPath, paste(DemoBoxName, 
            "-", no, ".gif", sep = ""))
        if (0 < no) {
            print(text.pic)
            text.ok <- TRUE
            if (file.exists(text.pic)) 
                tcl("createandshowimagegif", tw, text.pic, "0.0")
            else {
                text.pic <- sub(".gif", ".ppm", text.pic)
                if (file.exists(text.pic)) 
                  tcl("createandshowimageppm", tw, text.pic, 
                    "0.0")
                else {
                }
            }
        }
        if (debug) 
            cat("get chunk and pic: done")
    }
    show.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secno)))
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunks)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunks)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        if (debug) 
            cat("put code", no)
        code <- paste(chunks[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttext, "0.0", "end")
            tkinsert(ttext, "0.0", code)
            tclvalue(secno) <- as.character(no)
        }
        if (debug) 
            cat("put text", no)
        tkdelete(tw, "0.0", "end")
        text.pic <- file.path(DemoBoxPath, paste(DemoBoxName, 
            "-", no, ".gif", sep = ""))
        if (0 < no) {
            print(text.pic)
            text.ok <- TRUE
            if (file.exists(text.pic)) 
                tcl("createandshowimagegif", tw, text.pic, "0.0")
            else {
                text.pic <- sub(".gif", ".ppm", text.pic)
                if (file.exists(text.pic)) 
                  tcl("createandshowimageppm", tw, text.pic, 
                    "0.0")
                else {
                }
            }
        }
        if (debug) 
            cat("get chunk and pic: done")
    }
    eval.code <- function(...) {
        code <- tclvalue(tkget(ttext, "0.0", "end"))
        code.orig <- code <- unlist(strsplit(code, "\n"))
        code <- code[!substring(code, 1, 1) == "#"]
        if (length(code) == 0) {
            cat("ok\n")
            return()
        }
        result <- try(eval(parse(text = code), envir = where))
        code.orig <- sub("#([0-9]+):", "##wnt-Code-Chunk:\\1-begin#", 
            code.orig)
        code.orig <- sub("#:([0-9]+)", "##wnt-Code-Chunk:\\1-end#", 
            code.orig)
        h <- get("allcodechunks", envir = where)
        h <- c(h, paste("<", "<*>", ">=", sep = ""), code.orig, 
            "\n@\n")
        assign("allcodechunks", h, envir = where)
        code <- sub("^ *", "", code)
        code <- code[nchar(code) > 0]
        lexpr <- rev(code)[1]
        lexpr <- substring(lexpr, 1, 4)
        if (length(code) == 0 || is.null(lexpr) || is.na(lexpr)) 
            return()
        plot.res <- c("plot", "boxp", "par(", "abli", "pie(", 
            "hist", "axis", "show", "lsfi", "pair", "ylab", "help", 
            "qqli", "qqno", "qqpl", "rug(", "lege", "segm", "text", 
            "xlab", "poin", "line", "titl", "eda(", "imag", "vgl.", 
            "curv")
        if (any(plot.res == lexpr)) {
            cat("plot generated\n")
            return()
        }
        if (is.null(result) || is.na(result) || lexpr == "prin" || 
            lexpr == "cat(") {
            cat("ok\n")
            return()
        }
        if (is.list(result) && length(names(result)) > 0 && names(result)[1] == 
            "ID") 
            return()
        no <- as.character(as.numeric(tclvalue(secno)))
        cat("result of code chunk", no, ":\n")
        if (class(result) == "try-error") {
            class(result) <- "character"
            cat(result, "\n")
        }
        else {
            print(result)
        }
    }
    exit.function <- function(...) {
        tkdestroy(top)
        h <- get("allcodechunks", envir = where)
        if (length(h) < 2) 
            return()
        filename <- tkgetSaveFile(filetypes = "{{Paper Files} {.rev}}", 
            title = "Do you want to save the activated R statements?")
        if (!is.character(filename)) 
            filename <- tclvalue(filename)
        if (filename == "") {
            cat("Demo function stopped without saving\n")
            return()
        }
        if (0 == length(grep("rev$", filename))) 
            filename <- paste(filename, ".rev", sep = "")
        try(cat(h, sep = "\n", file = filename))
        cat(paste("Remark: activated statements saved in\n   ", 
            filename, "\n"))
        return()
    }
    top <- tktoplevel()
    topf <- tkframe(top)
    tkpack(topf, fill = "both", expand = "y")
    topHF <- tkframe(top)
    if (missing(main)) 
        main <- paste(DemoBoxName)
    tkwm.title(top, main)
    geo <- paste(geo.width, "x", geo.height, "+10+10", sep = "")
    tkwm.geometry(top, geo)
    tkpack(tframe <- tkframe(topf), fill = "x")
    tkpack(tw <- tktext(tframe), expand = "yes", fill = "x")
    tkconfigure(tframe, height = tw.height, width = w.width)
    tw.height.act <- tclVar("0")
    tclvalue(tw.height.act) <- as.character(tw.height)
    tkconfigure(tw, height = tw.height, width = w.width)
    .Tcl(paste("", "proc createandshowimagegif {w im place} {", 
        "global imageno", "set imageno [image create photo -format gif -file $im]", 
        "$w image create $place -image $imageno", "}", "proc createandshowimageppm {w im place} {", 
        "global imageno", "set imageno [image create photo -format ppm -file $im]", 
        "$w image create $place -image $imageno", "}", sep = "\n"))
    if (debug) 
        cat("pack widget for textual explanations / image: done")
    tf <- tkframe(topf)
    butw <- "6"
    butwh <- "3"
    butwa <- "1"
    tkevent.add("<<Paste>>", "<Control_L><v>")
    bexit <- tkbutton(tf, text = "Exit", width = butwh)
    beval <- tkbutton(tf, text = "Eval", width = butwh)
    bnext <- tkbutton(tf, text = ">", width = butwa)
    tkconfigure(bnext, cursor = "right_side")
    bback <- tkbutton(tf, text = "<", width = butwa)
    tkconfigure(bback, cursor = "left_side")
    tkbind(topf, "<<EvalRCode>>", eval.code)
    tkbind(topf, "<<Next>>", show.next.number)
    tkbind(topf, "<<Back>>", show.back.number)
    lno <- tkentry(tf, textvariable = secno, width = butwh)
    labno <- tklabel(tf, text = "Demo:", width = butw)
    tkpack(beval, labno, bback, lno, bnext, side = "left")
    tkconfigure(bexit, command = exit.function)
    tkconfigure(bnext, command = show.next.number)
    tkconfigure(bback, command = show.back.number)
    tkconfigure(beval, command = eval.code)
    tkbind(lno, "<KeyRelease>", show.number)
    if (debug) 
        cat("pack control buttons: done")
    tkpack(bexit, bigger.but <- tkbutton(tf, text = "v", width = butwa), 
        smaller.but <- tkbutton(tf, text = "^", width = butwa), 
        side = "right")
    tkconfigure(bigger.but, cursor = "bottom_side")
    tkconfigure(smaller.but, cursor = "top_side")
    bigger.tw <- function() {
        tclvalue(tw.height.act) <- tw.height <- as.character(min(as.numeric(tw.height) + 
            as.numeric(cw.height) - 3, as.numeric(tclvalue(tw.height.act)) + 
            5))
        tkconfigure(tw, height = tw.height)
    }
    smaller.tw <- function() {
        tclvalue(tw.height.act) <- tw.height <- as.character(max(1, 
            as.numeric(tclvalue(tw.height.act)) - 5))
        tkconfigure(tw, height = tw.height)
    }
    tkconfigure(bigger.but, command = bigger.tw)
    tkconfigure(smaller.but, command = smaller.tw)
    tkpack(tf, side = "top", fill = "x")
    if (debug) 
        cat("construct a lower and upper button for text widget: done")
    ttext <- tktext(topf, height = 19, background = "#f7fffF", 
        font = "-Adobe-courier-Medium-R-Normal--18-180-*")
    tkpack(ttext, side = "bottom", fill = "both", expand = "y")
    tkbind(ttext, "<<Paste>> { catch {%W insert insert [selection get -selection CLIPBOARD] } }")
    if (debug) 
        cat("construct text widget for code: done")
    tclvalue(secno) <- as.character("1")
    show.number()
    print(where)
    tfH <- tkframe(topHF)
    secnoH <- tclVar("1")
    Show.next.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secnoH)) + 1)
        chunksH <- get("chunksH", envir = where)
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunksH)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunksH)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("# sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        code <- paste(chunksH[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttextH, "0.0", "end")
            tkinsert(ttextH, "0.0", code)
            tclvalue(secnoH) <- as.character(no)
        }
    }
    Show.back.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secnoH)) - 1)
        chunksH <- get("chunksH", envir = where)
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunksH)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunksH)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("# sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        code <- paste(chunksH[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttextH, "0.0", "end")
            tkinsert(ttextH, "0.0", code)
            tclvalue(secnoH) <- as.character(no)
        }
    }
    Show.number <- function(...) {
        no <- as.character(as.numeric(tclvalue(secnoH)))
        chunksH <- get("chunksH", envir = where)
        no.start <- grep(paste("^#", no, ":$", sep = ""), chunksH)
        no.end <- grep(paste("^#:", no, "$", sep = ""), chunksH)
        if (length(no.end) == 0 || is.na(no.end) || is.na(no.start) || 
            is.nan(no.end) || is.nan(no.start)) {
            cat("# sorry, chunk number '", no, "' wrong!\n")
            return()
        }
        code <- paste(chunksH[no.start:no.end], collapse = "\n")
        if (0 < length(code)) {
            tkdelete(ttextH, "0.0", "end")
            tkinsert(ttextH, "0.0", code)
            tclvalue(secnoH) <- as.character(no)
        }
    }
    Eval.code <- function(...) {
        code <- tclvalue(tkget(ttextH, "0.0", "end"))
        code.orig <- code <- unlist(strsplit(code, "\n"))
        code <- code[!substring(code, 1, 1) == "#"]
        if (length(code) == 0) {
            cat("ok\n")
            return()
        }
        result <- try(eval(parse(text = code), envir = where))
        code.orig <- sub("#([0-9]+):", "##wnt-Code-Chunk:\\1-begin#", 
            code.orig)
        code.orig <- sub("#:([0-9]+)", "##wnt-Code-Chunk:\\1-end#", 
            code.orig)
        h <- get("allcodechunks", envir = where)
        h <- c(h, paste("<", "<*>", ">=", sep = ""), code.orig, 
            "\n@\n")
        assign("allcodechunks", h, envir = where)
        code <- sub("^ *", "", code)
        code <- code[nchar(code) > 0]
        lexpr <- rev(code)[1]
        lexpr <- substring(lexpr, 1, 4)
        if (length(code) == 0 || is.null(lexpr) || is.na(lexpr)) 
            return()
        plot.res <- c("plot", "boxp", "par(", "abli", "pie(", 
            "hist", "axis", "show", "lsfi", "pair", "ylab", "help", 
            "qqli", "qqno", "qqpl", "rug(", "lege", "segm", "text", 
            "xlab", "poin", "line", "titl", "eda(", "imag", "vgl.", 
            "curv")
        if (any(plot.res == lexpr)) {
            cat("Plot erstellt\n")
            return()
        }
        if (is.null(result) || is.na(result) || lexpr == "prin" || 
            lexpr == "cat(") {
            cat("ok\n")
            return()
        }
        if (is.list(result) && length(names(result)) > 0 && names(result)[1] == 
            "ID") 
            return()
        no <- as.character(as.numeric(tclvalue(secnoH)))
        cat("Result of code chunk", no, ":\n")
        if (class(result) == "try-error") {
            class(result) <- "character"
            cat(result, "\n")
        }
        else {
            print(result)
        }
        cat("ok\n")
    }
    Exit.function <- function() {
        tkpack(topf, fill = "both", expand = "y")
        tkwm.title(top, main)
        tkpack.forget(topHF)
        return()
        filename <- tkgetSaveFile(filetypes = "{{Paper Files} {.rev}}", 
            title = "Do you want to save the activated R statements?")
        if (!is.character(filename)) 
            filename <- tclvalue(filename)
        if (filename == "") {
            cat("History function stopped without saving\n")
            return()
        }
        if (0 == length(grep("rev$", filename))) 
            filename <- paste(filename, ".rev", sep = "")
        h <- get("allcodechunks", envir = where)
        try(cat(h, sep = "\n", file = filename))
        cat(paste("Remark: activated statements saved in\n   ", 
            filename, "\n"))
        return()
    }
    ttextH <- tktext(topHF, background = "#f7fffF", font = "-Adobe-courier-Medium-R-Normal--18-180-*")
    tkpack(tfH, side = "bottom", fill = "x")
    tkpack(ttextH, side = "bottom", fill = "both", expand = "y")
    bShowHistory <- tkbutton(tf, text = "History", width = butw)
    bexitH <- tkbutton(tfH, text = "Quit", width = butwh)
    bevalH <- tkbutton(tfH, text = "Eval", width = butwh)
    bnextH <- tkbutton(tfH, text = ">", width = butwa)
    bbackH <- tkbutton(tfH, text = "<", width = butwa)
    tkbind(top, "<<EvalRCode>>", Eval.code)
    if (!substring(version$os, 1, 6) == "darwin") {
        tkbind(top, "<<Next>>", Show.next.number)
        tkbind(top, "<<Back>>", Show.back.number)
    }
    lnoH <- tkentry(tfH, textvariable = secnoH, width = butwh)
    linfoH <- tklabel(tfH, text = "chunk:")
    tkpack(bevalH, linfoH, bbackH, lnoH, bnextH, side = "left")
    tkpack(bexitH, side = "right")
    tkconfigure(bexitH, command = Exit.function)
    tkconfigure(bnextH, command = Show.next.number)
    tkconfigure(bbackH, command = Show.back.number)
    tkconfigure(bevalH, command = Eval.code)
    tkevent.add("<<Paste>>", "<Control_L><v>")
    tkbind(lno, "<KeyRelease>", Show.number)
    tclvalue(secnoH) <- as.character(no)
    if (substring(version$os, 1, 6) == "darwin") {
        mac.paste <- function(...) {
            try({
                .Tcl("clipboard append hello")
                .Tcl("clipboard clear")
                news <- base::scan(file = pipe("pbpaste", "r"), 
                  what = "", sep = "\n", blank.lines.skip = FALSE)
                tkinsert(ttextH, "insert", paste(news, collapse = "\n"))
            })
            tksee(ttextH, "insert - 7 lines")
            tksee(ttextH, "insert + 7 lines")
        }
        tkbind(ttextH, "<Control_L><v>", mac.paste)
        mac.copy <- function(...) {
            news <- ""
            try(news <- tclvalue(.Tcl("if {[catch {clipboard get}]} {set aa empty} {set aa full}")))
            if (news == "empty") 
                return()
            try({
                news <- tclvalue(.Tcl("set aaa [selection get -selection CLIPBOARD]"))
                tmp.file.name <- tempfile("rt-tmp")
                base::cat(news, file = tmp.file.name)
                system(paste("pbcopy < ", tmp.file.name))
                .Tcl("clipboard append hello")
                .Tcl("clipboard clear")
            })
        }
        tkbind(ttextH, "<Control_L><c>", mac.copy)
        tkevent.add("<<extract>>", "<Control_L><c><KeyRelease>")
        tkbind(ttextH, "<<extract>>", mac.copy)
    }
    else {
        tkevent.add("<<Paste>>", "<Control_L><v>")
        tkbind(ttextH, "<<Paste>> { catch {%W insert insert [selection get -selection CLIPBOARD] } }")
    }
    ShowHistory <- function(...) {
        chunksH <- get("allcodechunks", envir = where)
        if (length(chunksH) < 2) 
            return()
        allcodechunks <- get("allcodechunks", envir = where)
        tkpack.forget(topf)
        tkpack(topHF, fill = "both", expand = "y")
        tkwm.title(top, "history of evaluations")
        chunksH <- unlist(strsplit(chunksH, "\n"))
        chunksH <- sub("^Report", "##Report", chunksH[-1])
        idx <- grep(paste("^<", "<", sep = ""), chunksH)
        chunksH[idx] <- paste("#", 1:length(idx), ":", sep = "")
        idx <- grep("^@", chunksH)
        chunksH[idx] <- paste("#:", 1:length(idx), sep = "")
        tclvalue(secnoH) <- as.character(length(idx))
        filename <- paste("tmp-demo", ".R", sep = "")
        try(cat(chunksH, sep = "\n", file = filename))
        assign("chunksH", chunksH, envir = where)
        cat(paste("Remark: statements of history have been saved in:  ", 
            filename, "\n"))
        Show.number()
    }
    tkconfigure(bShowHistory, command = ShowHistory)
    tkpack(bShowHistory)
}
DemoBoxPlayer( SlideWidthFactor = 2 , SlideHeightFactor = 1 , CodeHeightFactor = 1 )
