#1:
##<Testchunk>=##
base::cat("x <- co2",file="tt.R")
#:1
#2:
##<*>=##
ts.zoom<-function(x){
  refresh.code<-function(...){
  # Vorbereitung
    start<-slider(no=1)*1000; end<-slider(no=2)*1000
    if(start>end) start<-slider(set.no.value=c(1,round(end/1000-1)))
  # Plot
    plot(x,xlim=c(min(start,end), max(start,end)))
  }
  slider(refresh.code,
         sl.names=c("begin: index * 0.001",  "end: index * 0.001 "),
         sl.mins=c(0,0),
         sl.maxs=c(length(x)/1000,length(x)/1000),
         sl.deltas=c(1,1),
         sl.defaults=c(1,length(x)/1000)
  )
}
ts.zoom(runif(10000))
#:2
#3:
##<*>=##
# Initialisierungen
types <- c(0,       1,   50) # Auszahlungstypen
probs <- c(0.54, 0.45, 0.01) # Wahrscheinlichkeiten der Typen
n.rot <- 3                   # Anzahl der Drehungen
seed  <- 13                  # Zufallsstart
runs  <- 10000               # Versuche
par(mfrow=2:1)               # graphische Parameter
# Simulator definieren
simulator <- function(x) sample(types, n.rot, prob=probs, replace=TRUE)
# Ziehungen
set.seed(seed)
results <- sapply(1:runs, simulator)
# Auswertung
Auszahlungen <- colSums(results)
cat("Mittel der Auszahlungen:", h <- mean(Auszahlungen),"\n" )
cat("relative Looser-Anzahl: ", mean(Auszahlungen == 0),"\n" )
boxplot(Auszahlungen, horizontal=TRUE); abline(v=h,col="red")
plot(1:runs, cumsum(Auszahlungen)/(1:runs), type="l", bty="n")

#:3
#0:
##<start>=##
print("hello world")

#:0
#4:
##<*>=##
# "Personen-Simulator" definierten
simulator <- function(x) sample(size = 3,  c(50,1,0), prob = c(1,45,54), replace = TRUE)
# Wiederholungszahl setzen 
n <- 1000
# Zufallsstart setzen 
set.seed(13)
# Simulation anstoßen 
auszahlungen <- sapply(1:n, simulator)
# Einzelauszahlungen auswerten /mitteln (Aufgabe 4a)
print(mean(colSums(auszahlungen)))
# relative Häufigkeit für keinen Gewinn
mean(0==colSums(auszahlungen))

#:4
#5:
##<*>=##
result <- 1:10
for(i in 1:10){
  stich.weg <- i-1
  # x, m, n, k :: white player, white total, black total, number choosen
  herz <- 4; not.herz <- 36 - stich.weg*4
  ws.spieler.1 <- dhyper(1, herz, not.herz, 10-stich.weg)
  herz <- herz-1; not.herz <- not.herz - (10-stich.weg) + 1
  ws.spieler.2 <- dhyper(1, herz, not.herz, 10-stich.weg)
  herz <- herz-1; not.herz <- not.herz - (10-stich.weg) + 1
  ws.spieler.3 <- dhyper(1, herz, not.herz, 10-stich.weg)
  herz <- herz-1; not.herz <- not.herz - (10-stich.weg) + 1
  ws.spieler.4 <- dhyper(1, herz, not.herz, 10-stich.weg) # zum Check
  ws <- ws.spieler.1*ws.spieler.2*ws.spieler.3*ws.spieler.4
  result[i] <- ws
} 
plot(1:10, result, type="h", ylim=0:1)

#:5
#6:
##<*>=##
lambda <- 3
x <- 0:20
f.x <- dpois(x, lambda)
F.x <- ppois(x, lambda)
par(mfrow=c(2,2))
plot(x, f.x, type="h", lwd=4, col="red")
title(paste("lambda =", round(lambda,2)))
plot(x, F.x, type="S", lwd=4, col="blue")
n <- 1000
stpr <- rpois(n, lambda)
boxplot(stpr, horizontal=TRUE, ylim=range(x))
# open.demo.box(file.name = "unfaelleBI", "90", "65")

#:6
